deprecations:
  - feature_name: "Planned removal of legacy storage in 14.0"
    due: April 22, 2021
    reporter: fzimmer
    description: |
      GitLab currently supports two types of storage for repositories: [Legacy storage](https://docs.gitlab.com/ee/administration/repository_storage_types.html#legacy-storage) and [hashed storage](https://docs.gitlab.com/ee/administration/repository_storage_types.html#hashed-storage). Hashed storage makes the folder structure immutable and results in performance and security improvements.

      Hashed storage has been available since GitLab 10.0 and is on by default since GitLab 12.0. GitLab.com has been fully migrated to hashed storage. With GitLab 13.0 legacy storage is deprecated and we are planning to fully remove legacy storage in 14.0.

      **In 13.0:**
        * Legacy storage is deprecated and usage is strongly discouraged. Please follow instructions on [how to migrate fully to hashed storage](https://docs.gitlab.com/ee/administration/raketasks/storage.html#migrate-to-hashed-storage).
        * Administrators will no longer be able to disable hashed storage for new projects.
        * New projects and renamed projects will use hashed storage by default.
        * When renaming or moving projects they will be migrated to hashed storage automatically.

      **In 13.2:**
        * Upon upgrading to 13.2, all projects still in legacy storage will be automatically migrated via a background migration.
        * Some new features may require hashed storage and won't be available when using legacy storage.

      **In 14.0:**
        * Legacy storage support will be completely removed from GitLab. Users must migrate to hashed storage before upgrading to 14.0.
